defmodule Liaison.MixProject do
  use Mix.Project

  @version "0.1.0"

  def project do
    [
      app: :liaison,
      version: @version,
      elixir: "~> 1.8",
      description: "Keeping nodes connected",
      elixirc_paths: elixirc_paths(Mix.env()),
      start_permanent: Mix.env() == :prod,
      deps: deps(),
      package: package(),
      docs: docs(),
      aliases: aliases()
    ]
  end

  defp elixirc_paths(:test), do: ["lib", "test/support"]
  defp elixirc_paths(_), do: ["lib"]

  def application do
    [
      mod: {Liaison.Application, []},
      extra_applications: [:logger]
    ]
  end

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      {:dialyze, "~> 0.2.0", only: :dev},
      {:ex_doc, "~> 0.19", only: :dev, runtime: false}
    ]
  end

  defp aliases do
    [
      test: "test --no-start"
    ]
  end

  defp package do
    [
      maintainers: ["Jonathan Howell (arcticgizmo)"],
      licenses: ["MIT"],
      links: %{github: "https://github.com/arcticgizmo/liaison"},
      files: ~w(lib CHANGELOG.md LICENSE.md mix.exs README.md)
    ]
  end

  defp docs do
    [
      main: "Liaison",
      source_ref: "v#{@version}",
      source_url: "https://github.com/arcticgizmo/liaison"
    ]
  end
end
